/*

 atokconv

 ƥȥեδɤϤ餫ѴƤɬפޤ
  GPL2 äƤȤǡ

*/

#include <stdio.h>
#include <string.h>

#define MAX_CHAR 256
#define MAX_HINSHI 100

/* Ϥ뼭μ */
enum {
    DIC_ATOK,
    DIC_VJE,
    DIC_WNN6,
    DIC_CAN,
    DIC_MSIME,
    DIC_FWNN,
};

/* ʻι¤(HINSHI) */
typedef struct hinshi {
    char *atok;
    char *vje;
    char *wnn6;
    char *canna;
    char *msime;
    char *fwnn;
} HINSHI;


/* ʻбơ֥ */
static HINSHI table[] =
{
    {"̾", "̾", "̾", "#T35", "̾", "̾"},
    {"ͭ", "̾", "", "#JN", "", "̾"},
    {"ͭ̾", "̾", "̾", "#JN", "̾", "̾"},
    {"ͭ¾", "̾", "ͭ̾", "#KK", "̾", "ͭ̾"},
    {"ͭ̾", "̾ʬ", "̾", "#CN", "̾¾", "̾&̾"},
    {"ͭȿ", "̾ȿ", "", "#KK", "ͭ̾", "ͭ̾"},
    {"ͭ", "̾", "ͭ̾", "#KK", "ͭ̾", "ͭ̾"},
    {"ͭ", "̾", "ͭ̾", "#KK", "ͭ̾", "ͭ̾"},
    {"̾쥵", "̾", "()&̾", "#T30", "̾", "()&̾"},
    {"̾쥶", "̾¾", "()&̾", "#ZX", "̾", "()"},
    {"̾ư", "ư", "ư&̾", "#T05", "ư̾", "ư"},
    {"̾ư", "̾", "ư&&̾", "#T00", "ѷư̾", "()&̾"},
    {"", "", "", "#NN", "̾", ""},
    {"", "", "", "#F14", "", ""},
    {"Ϣλ", "Ϣ", "Ϣλ", "#RT", "Ϣλ", "Ϣλ"},
    {"ư", "ư", "³,ư", "#CJ", "ư", "³,ư"},
    {"³", "³", "³,ư", "#CJ", "³", "³,ư"},
    {"Ω", "Ω", "ñȸ", "#CJ", "Ω", "³,ư"},
    {"Ƭ", "Ƭ", "Ƭ", "#PRE", "Ƭ", "Ƭ"},
    {"", "", "Ƭ", "#NNPRE", "", "Ƭ"},
    {"", "", "", "#SUC", "", ""},
    {"", "", "", "#JS", "", ""},
    {"Ը", "", "Ը", "#K5r", "Ը", "Ը"},
    {"Ը", "", "Ը", "#G5r", "Ը", "Ը"},
    {"Ը", "", "Ը", "#S5r", "Ը", "Ը"},
    {"Ը", "", "Ը", "#T5r", "Ը", "Ը"},
    {"ʹԸ", "ʸ", "ʹԸ", "#N5r", "ʹԸ", "ʹԸ"},
    {"йԸ", "и", "йԸ", "#B5r", "йԸ", "йԸ"},
    {"޹Ը", "޸", "޹Ը", "#M5r", "޹Ը", "޹Ը"},
    {"Ը", "", "Ը", "#R5r", "Ը", "Ը"},
    {"Ը", "", "Ը", "#W5r", "Ը", "Ը"},
    {"ϹԻ", "ϻ", "ϹԸ", "#B05", "??", "ϹԸ"},
    {"ư", "", "", "#KS", "ư", ""},
    {"ư", "", "(Ԥ)", "#KX", "??", "(Ԥ)"},
    {"ư", "", "()", "#SX", "??", "()"},
    {"ư", "", "()", "#ZX", "??", "()"},
    {"ƻ", "", "ƻ", "#KY", "ƻ", "ƻ"},
    {"ƻ쥦", "Ƥ", "ƻϢѷ", "#KY", "ƻ", "ƻ"},
    {"ư", "ư", "ư", "#T05", "ư", "ư"},
    {"ư", "ư", "ư()", "#F00", "ư", "ư()"},
    {"ñ", "ñ", "ñ", "#KJ", "ñ", "ñ"},
};


/* ץȥ */
int main(int argc, char *argv[]);
void dic_writer(FILE * fp, char *yomi, char *kanji, char *hinshi, int dictype);
char *hinshi_converter(char *hinshi_data, struct hinshi *taiou, int dictype);
char *hinshi_remove_atok_mark(char *hinshi_data);


/* ʻǡ ATOK μ̵ */
char *hinshi_remove_atok_mark(char *hinshi_data)
{
    int hinshi_last_char;

    /* Ǹ1ʸ */
    hinshi_last_char = strlen(hinshi_data) - 1;

    /* Ǹ1ʸ̵ξϺ */
    switch ( hinshi_data[hinshi_last_char]) {
    case '$':
    case '*':
	hinshi_data[hinshi_last_char] = '\0';
	break;
    default: /* ̵ǤϤʤϲ⤷ʤ */
	break;
    }
    return(hinshi_data);
}

/* ʻѴ */
char *hinshi_converter(char *hinshi_data, struct hinshi *taiou, int dictype)
{
    int i;
    int hinshi_number;

    /*
     * ʻο
     * sizeof Ȥäƹ¤ΤΥΤϴĶˤä礭㤦Τ 
     */
    hinshi_number = sizeof(table) / sizeof(HINSHI);

    /* ʻڤؤʤå */
    for (i = 0; i < hinshi_number; i++) {
	/* ΤбϷˤäΤ֤ */
	if (!strcmp(hinshi_data, table[i].atok)) {
	    /* Wnn6 ξ */
	    switch ( dictype ) {
	    case DIC_WNN6:
		return (table[i].wnn6);
		break;
	    /* Vje-Delta ξ */
	    case DIC_VJE:
		return (table[i].vje);
		break;
	    /* Canna ξ */
	    case DIC_CAN:
		return (table[i].canna);
		break;
	    /* MS-IME ξ */
	    case DIC_MSIME:
		return (table[i].msime);
		break;
	    /* FreeWnn ξ */
	    case DIC_FWNN:
		return (table[i].fwnn);
		break;
	    /* ξ */
	    default:
		fprintf(stderr, "顼:Ǥ");
	    }
	}

    }
    return ("ñ");
}

/* 񤭹 */
void dic_writer(FILE * fp, char *yomi, char *kanji, char *hinshi, int dictype)
{
    switch ( dictype ) {
    /* Wnn6 ⤷ FreeWnn ν */
    case DIC_WNN6:
    case DIC_FWNN:
        fprintf(fp, "%s\t%s\t%s\t0\n", yomi, kanji, hinshi);
	break;
    /* Vje-Delta ν */
    case DIC_VJE:
	fprintf(fp, "%s\t%s\t%s\n", yomi, kanji, hinshi);
	break;
    /* Canna ν */
    case DIC_CAN:
	fprintf(fp, "%s\t%s\t%s\n", yomi, hinshi, kanji);
	break;
    /* MS-IME ν */
    case DIC_MSIME:
	fprintf(fp, "%s\t%s\t%s\n", yomi, kanji, hinshi);
	break;
    /* ξ */
    default:
	fprintf(stderr, "顼:񤭹༭Ǥ");
    }
}

/* ᥤ */
int main(int argc, char *argv[])
{
    FILE *finput_p;		/* ϥեݥ */
    FILE *foutput_p;		/* ϥեݥ */

    HINSHI taiou[MAX_HINSHI];	/* ʻбѹ¤ */

    char yomi_data[MAX_CHAR];	/* ɤߥǡ */
    char kanji_data[MAX_CHAR];	/* ǡ */	
    char hinshi_data[MAX_CHAR];	/* ʻǡ */
    int dictype;                /*  */

    char buffer[MAX_CHAR];	/* ɤ߹ѥХåե */
    int tango_counter = 0;	/* ɽñ */


    /* ­ʤɽƽλ */
    if (argc != 4) {
	printf("ˡ: atok2vje [ץ] [ATOKƥȼ] [ϥƥȼ]\n");
	printf("  -w Wnn6 ΥƥȼϤޤ\n");
	printf("  -v Vje-Delta ΥƥȼϤޤ\n");
	printf("  -c Canna ΥƥȼϤޤ\n");
	printf("  -m MS-IME ΥƥȼϤޤ\n");
	printf("  -f FreeWnn ΥƥȼϤޤ\n");
	return (0);
    }


    /*  */
    if (!strncmp(argv[1], "-w", 2)) {
	printf("Wnn6 Ѵޤ\n");
	dictype = DIC_WNN6;
    }
    else if (!strncmp(argv[1], "-v", 2)) {
	printf("Vje-Delta Ѵޤ\n");
	dictype = DIC_VJE;
    }
    else if (!strncmp(argv[1], "-c", 2)) {
	printf("Canna Ѵޤ\n");
	dictype = DIC_CAN;
    }
    else if (!strncmp(argv[1], "-m", 2)) {
	printf("MS-IME Ѵޤ\n");
	dictype = DIC_MSIME;
    }
    else if (!strncmp(argv[1], "-f", 2)) {
	printf("FreeWnn Ѵޤ\n");
	dictype = DIC_FWNN;
    }
    else {
	fprintf(stderr, "λְ꤬äƤޤ\n");
	return (-1);
    }


    /* ϥե뤬ʤϥ顼֤ƽλ */
    if ((finput_p = fopen(argv[2], "r")) == NULL) {
	fprintf(stderr, "顼: %s ޤ\n", argv[1]);
	return (-1);
    }


    /* ϥե뤬ʤϥ顼֤ƽλ */
    if ((foutput_p = fopen(argv[3], "w")) == NULL) {
	fprintf(stderr, "顼: %s ޤ\n", argv[2]);
	fclose(finput_p);	/* Ǥ˳ƤϥեĤ */
	return (-1);
    }


    /* ᥤ */
    while (fgets((char *) buffer, sizeof(buffer), finput_p)) {
	if (3 > sscanf((char *) buffer, "%s %s %s", yomi_data, kanji_data, hinshi_data)) {
	    continue;
	} else {
	    /* ȹ(Ƭʸ"!!")Ǥʤʤн񤭹ߤԤ */
	    if (yomi_data[0] != '!' && yomi_data[1] != '!') {
		dic_writer(foutput_p, yomi_data, kanji_data, hinshi_converter(hinshi_remove_atok_mark(hinshi_data), taiou, dictype), dictype);
		tango_counter++;	/* ñ䤹 */
#ifdef DEBUG
		printf("%d ĤñѴޤ\r", tango_counter);
#endif
	    }
	}
    }


    /* եĤ */
    fclose(finput_p);
    fclose(foutput_p);


    /* 񤭽Фñɽ */
    printf("%6d ĤñѴޤ\n", tango_counter);


    /* ｪλ */
    return (0);
}
